/* Generates a dictionary file from a given word list

   By James Stanley

   No license - Use as you wish */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

int main(int argc, char **argv) {
  FILE *words;
  FILE *dict;
  char buff[64];
  char out[16];
  int i, n;
  char *allowed = "abcdefghijklmnopqrstuvwxyz";
  
  if(argc != 3) {
    printf("USAGE: %s wordlist dictionary\n", argv[0]);
    exit(1);
  }
  
  words = fopen(argv[1], "r");
  if(!words) {
    printf("Unable to load %s as word list\n", argv[1]);
    exit(1);
  }
  dict = fopen("/tmp/dictionary", "w");
  if(!dict) {
    printf("Unable to write to /tmp/dictionary as a temporary file\n");
    fclose(words);
    exit(1);
  }
  
  while(!feof(words)) {
    fgets(buff, 64, words);
    if(buff[strlen(buff) - 1] == '\n') buff[strlen(buff) - 1] = '\0';
    if(strlen(buff) <= 9) {
      n = 0;
      for(i = 0; i < strlen(buff); i++) {
        if(strchr(allowed, tolower(buff[i]))) {
          out[n] = tolower(buff[i]);
          n++;
        }
      }
      out[n] = '\0';
      fprintf(dict, "%s\n", out);
    }
  }
  
  fclose(words);
  fclose(dict);
  
  snprintf(buff, 64, "sort -u -b /tmp/dictionary > '%s'", argv[2]);
   
  system(buff);
  
  return 0;
}
