/* Solves the countdown numbers game

   By James Stanley

   No license - Use as you wish */

#include <stdio.h>
#include <stdlib.h>

#define DIV 0
#define MUL 1
#define ADD 2
#define SUB 3

int number[6];
int used[6];
int target;

int find_answer(int numbers, int answer) {
  int i, j;
  int myans;
  
  numbers--;
  if(numbers == -1) return 0;
  
  for(i = 0; i < 6; i++) {
    if(!used[i]) {
      for(j = 0; j < 4; j++) {
        switch(j) {
          case DIV:
            myans = answer;
            if(number[i] != 0) {
              if((myans % number[i]) == 0) {
                myans /= number[i];
                used[i] = 1;
                if(myans == target) {
                  if(answer != 0) printf("%d / %d = %d\n", answer, number[i], myans);
                  return 1;
                }
                if(find_answer(numbers, myans)) {
                  if(answer != 0) printf("%d / %d = %d\n", answer, number[i], myans);
                  return 1;
                }
              }
              used[i] = 0;
            }
            break;
          case MUL:
            myans = answer;
            myans *= number[i];
            used[i] = 1;
            if(myans == target) {
              if(answer != 0) printf("%d * %d = %d\n", answer, number[i], myans);
              return 1;
            }
            if(find_answer(numbers, myans)) {
              if(answer != 0) printf("%d * %d = %d\n", answer, number[i], myans);
              return 1;
            }
            used[i] = 0;
            break;
          case ADD:
            myans = answer;
            myans += number[i];
            used[i] = 1;
            if(myans == target) {
              if(answer != 0) printf("%d + %d = %d\n", answer, number[i], myans);
              return 1;
            }
            if(find_answer(numbers, myans)) {
              if(answer != 0) printf("%d + %d = %d\n", answer, number[i], myans);
              return 1;
            }
            used[i] = 0;
            break;
          case SUB:
            myans = answer;
            myans -= number[i];
            used[i] = 1;
            if(myans == target) {
              if(answer != 0) printf("%d - %d = %d\n", answer, number[i], myans);
              return 1;
            }
            if(find_answer(numbers, myans)) {
              if(answer != 0) printf("%d - %d = %d\n", answer, number[i], myans);
              return 1;
            }
            used[i] = 0;
            break;
        }
      }
    }
  }
  return 0;
}

int main(int argc, char **argv) {
  int i;
  
  if(argc != 8) {
    printf("USAGE: %s n1 n2 n3 n4 n5 n6 target\n", argv[0]);
    exit(1);
  }
  
  for(i = 1; i <= 6; i++) {
    number[i - 1] = atoi(argv[i]);
  }
  
  target = atoi(argv[7]);
  
  printf("Please read answers bottom-up.\n");
  
  if(find_answer(6, 0)) return 0;
  if(find_answer(5, 0)) return 0;
  if(find_answer(4, 0)) return 0;
  if(find_answer(3, 0)) return 0;
  if(find_answer(2, 0)) return 0;
  if(find_answer(1, 0)) return 0;
  
  printf("Unfortunately, that doesn't seem to be possible, as there was no answer calculated.\n");
  
  return 0;
}
