/* Solves the countdown words game, teatime teaser, and conundrum

   By James Stanley

   No license - Use as you wish */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int main(int argc, char **argv) {
  FILE *dictionary;
  int i, j;
  char *letter;
  int letters;
  int minletters;
  int done;
  char buff[16];
  char word[16];
  char *allowed = "abcdefghijklmnopqrstuvwxyz";
  
  if(argc != 4) {
    printf("USAGE: %s dictionary letters minletters\nWhere dictionary is the dictionary file, letters are your nine letters, and minletters is the minimum word length to output.\n", argv[0]);
    exit(1);
  }
  
  letter = argv[2];
  letters = strlen(letter);
  if(letters != 9) printf("You should have got 9 letters. No matter, continuing anyway!\n");
  minletters = atoi(argv[3]);
  
  dictionary = fopen(argv[1], "r");
  if(!dictionary) {
    printf("Unable to load %s as dictionary\n", argv[1]);
    exit(1);
  }
  
  while(fgets(buff, 16, dictionary)) {
    if(buff[strlen(buff) - 1] == '\n') buff[strlen(buff) - 1] = '\0';
    strncpy(word, buff, 16);
    if(strlen(buff) >= minletters) {
      if(strlen(buff) > 9) printf("Your dictionary file contains '%s', which has more than 9 letters so is unlikely to come up as a valid word. I suggest running gendict to solve this.\n", buff);
      for(j = 0; j < strlen(buff); j++) {
        if(!strchr(allowed, buff[j])) printf("Your dictionary file contains '%s', which contains an invalid character. I suggest running gendict to solve this.\n", buff);
      }
      for(i = 0; i < letters; i++) {
        if(strchr(buff, letter[i])) {
          buff[strchr(buff, letter[i]) - buff] = '.';
          done = 1;
          for(j = 0; j < strlen(buff); j++) {
            if(buff[j] != '.') done = 0;
          }
          if(done) {
            printf("%s\n", word);
            break;
          }
        }
      }
    }
  }
  
  return 0;
}
